% interaction_A.m
function A = interaction_A(k,r,alph)
% A is a 3N x 3N matrix
% k: wavenumber
% r: N x 3 matrix, for x_j, y_j, z_j coordinates
% N: number of dipoles
% j = 1..N

% Eqn(6), Draine & Flatau, 
% Discrete-dipole approximation for scattering calculations
% pgs 1491-1499, Vol. 11, No. 4 (1994), J. Opt. Soc. Am. A 
[N,dummy] = size(r);
A = single(zeros(3*N,3*N));
I = eye(3);

tic
for jj=1:N
  [jj N];
  for kk=1:N
    if jj ~= kk
      rk_to_rj = r(jj,:)-r(kk,:);
      rjk = norm(rk_to_rj); %sqrt(sum((r(jj,:)-r(kk,:)).^2))
      rjk_hat = (rk_to_rj)/rjk;
      rjkrjk = rjk_hat'*rjk_hat;

      %Ajk = exp(i*k*rjk)/rjk*(k^2*((rjkrjk)-I) + (3*rjkrjk - I)*(1-i*k*rjk)/rjk^2); %derived from Jackson
      
      Ajk = exp(i*k*rjk)/rjk*(k^2*(rjkrjk - I) + (i*k*rjk-1)/rjk^2*(3*rjkrjk - I)); %Draine & Flatau
      
      A((jj-1)*3+1:jj*3,(kk-1)*3+1:kk*3) = Ajk;
      %A((kk-1)*3+1:kk*3,(jj-1)*3+1:jj*3) = Ajk;
    else
      A((jj-1)*3+1,(kk-1)*3+1) = 1/alph((jj-1)*3+1);
      A((jj-1)*3+2,(kk-1)*3+2) = 1/alph((jj-1)*3+2);
      A((jj-1)*3+3,(kk-1)*3+3) = 1/alph((jj-1)*3+3);
    end
  end
end
interact = toc
